within ;
model Centrifugal

  inner Modelica.Mechanics.MultiBody.World world annotation (Placement(
        transformation(
        extent={{-10,-10},{10,10}},
        rotation=0,
        origin={-90,0})));
  Modelica.Mechanics.MultiBody.Joints.Revolute revolute(
    n={0,1,0},
    phi(fixed=true),
    useAxisFlange=true,
    cylinderDiameter=0.5) annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=0,
        origin={-60,0})));
  Modelica.Mechanics.MultiBody.Joints.Revolute revolute1(
    n={0,0,1},
    cylinderLength=0.3,
    cylinderDiameter=0.2) annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=270,
        origin={-10,-20})));
  Modelica.Mechanics.MultiBody.Joints.Revolute revolute2(
    n={0,0,1},
    cylinderLength=0.3,
    cylinderDiameter=0.2) annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=270,
        origin={70,-20})));
  Modelica.Mechanics.MultiBody.Joints.Revolute revolute3(animation=false)
    annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=90,
        origin={-10,20})));
  Modelica.Mechanics.MultiBody.Joints.Revolute revolute4(animation=false)
    annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=90,
        origin={70,20})));
  Modelica.Mechanics.MultiBody.Joints.RevolutePlanarLoopConstraint revolute5(
      animation=false)
    annotation (Placement(transformation(extent={{20,60},{40,80}})));
  Modelica.Mechanics.MultiBody.Joints.RevolutePlanarLoopConstraint revolute6(n=
        {0,0,1}, animation=false)
    annotation (Placement(transformation(extent={{20,-80},{40,-60}})));
  Modelica.Mechanics.MultiBody.Joints.Prismatic prismatic(
    s(fixed=true, start=1),
    n={0,1,0},
    boxWidth=0.15)
    annotation (Placement(transformation(extent={{18,-10},{38,10}})));
  Modelica.Mechanics.MultiBody.Forces.SpringDamperParallel springDamperParallel(
    s_unstretched=1,
    width=0.2,
    c=240,
    d=24) annotation (Placement(transformation(extent={{20,20},{40,40}})));
  Modelica.Mechanics.MultiBody.Parts.Body body(m=4, animation=false)
    annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=90,
        origin={-40,20})));
  Modelica.Mechanics.MultiBody.Parts.Body body1(m=2, sphereDiameter=0.3)
    annotation (Placement(transformation(extent={{80,-80},{100,-60}})));
  Modelica.Mechanics.MultiBody.Parts.Body body2(m=2, sphereDiameter=0.3)
    annotation (Placement(transformation(extent={{80,60},{100,80}})));
  Modelica.Mechanics.MultiBody.Parts.FixedTranslation fixedTranslation(r={1.3,0,
        0}) annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=270,
        origin={-10,-50})));
  Modelica.Mechanics.MultiBody.Parts.FixedTranslation fixedTranslation1(r={1.3,
        0,0}) annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=90,
        origin={70,-50})));
  Modelica.Mechanics.MultiBody.Parts.FixedTranslation fixedTranslation2(r={-1.3,
        0,0}) annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=90,
        origin={-10,50})));
  Modelica.Mechanics.MultiBody.Parts.FixedTranslation fixedTranslation3(r={-1.3,
        0,0}) annotation (Placement(transformation(
        extent={{-10,-10},{10,10}},
        rotation=270,
        origin={70,50})));
  Modelica.Mechanics.Rotational.Sources.ConstantTorque constantTorque(
      tau_constant=10)
    annotation (Placement(transformation(extent={{-92,30},{-72,50}})));
  annotation (uses(Modelica(version="3.1")), Diagram(graphics));
equation
  connect(revolute.frame_a, world.frame_b) annotation (Line(
      points={{-70,0},{-80,0}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(body.frame_a, revolute.frame_b) annotation (Line(
      points={{-40,10},{-40,0},{-50,0}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(revolute1.frame_a, revolute.frame_b) annotation (Line(
      points={{-10,-10},{-10,0},{-50,0}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(revolute6.frame_b, body1.frame_a) annotation (Line(
      points={{40,-70},{80,-70}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(revolute3.frame_a, revolute.frame_b) annotation (Line(
      points={{-10,10},{-10,0},{-50,0}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(revolute4.frame_a, prismatic.frame_b) annotation (Line(
      points={{70,10},{70,0},{38,0}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(prismatic.frame_a, revolute.frame_b) annotation (Line(
      points={{18,0},{-50,0}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(revolute5.frame_b, body2.frame_a) annotation (Line(
      points={{40,70},{80,70}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(revolute1.frame_b, fixedTranslation.frame_a) annotation (Line(
      points={{-10,-30},{-10,-32.5},{-10,-32.5},{-10,-35},{-10,-40},{-10,-40}}, 

      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(fixedTranslation.frame_b, revolute6.frame_a) annotation (Line(
      points={{-10,-60},{-10,-70},{20,-70}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(fixedTranslation1.frame_b, revolute2.frame_b) annotation (Line(
      points={{70,-40},{70,-30}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(fixedTranslation1.frame_a, revolute6.frame_b) annotation (Line(
      points={{70,-60},{70,-70},{40,-70}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(revolute2.frame_a, prismatic.frame_b) annotation (Line(
      points={{70,-10},{70,0},{38,0}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(revolute3.frame_b, fixedTranslation2.frame_a) annotation (Line(
      points={{-10,30},{-10,40}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(fixedTranslation2.frame_b, revolute5.frame_a) annotation (Line(
      points={{-10,60},{-10,70},{20,70}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(fixedTranslation3.frame_a, revolute5.frame_b) annotation (Line(
      points={{70,60},{70,70},{40,70}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(fixedTranslation3.frame_b, revolute4.frame_b) annotation (Line(
      points={{70,40},{70,30}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(springDamperParallel.frame_b, prismatic.frame_b) annotation (Line(
      points={{40,30},{52,30},{52,0},{38,0}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(springDamperParallel.frame_a, prismatic.frame_a) annotation (Line(
      points={{20,30},{6,30},{6,0},{18,0}},
      color={95,95,95},
      thickness=0.5,
      smooth=Smooth.None));
  connect(constantTorque.flange, revolute.axis) annotation (Line(
      points={{-72,40},{-60,40},{-60,10}},
      color={0,0,0},
      smooth=Smooth.None));
end Centrifugal;
